Lintcode--003

给出一个字符串数组S,找到其中所有的乱序字符串(Anagram)。如果一个字符串是乱序字符串,那么他存在一个字母集合相同,但顺序不同的字符串也在S中。

注意事项

所有的字符串都只包含小写字母

样例

对于字符串数组 ["lint","intl","inlt","code"]

返回 ["lint","inlt","intl"]

第一次尝试解决,方法复杂,且不能通过。代码如下:

class Solution {
public:
    /**
     * @param strs: A list of strings
     * @return: A list of strings
     */
    vector<string> anagrams(vector<string> &strs) {//vector<string> s;   //定义个一个字符串容器s
        // write your code here

        //先考虑边界情况,如果字符串数组s中的所有字符串,都不等长,则不存在乱序字符串;
        for(int i=0;i<strs.size();i++){
            int a[i]=strs[i].size();
        }
        for(int j=0;j<strs.size()-1;j++){
            for(int k=j+1;k<strs.size();k++){
                if(a[j]>0&&a[k]>0&&a[j]==a[k]){
                    vector<string> s;
                    s.push_back(strs[j]);
                    strs[j]=" ";
                    s.push_back(strs[k]);
                }
                else{
                    return null;
                }
            }
        }
        int letters[s.size()][26];
        memset(letters,0,letters);
        for (int m=0;m<s.size();m++){
            string ll;
            ll=s[i];
            for(n=0;n<ll.size();n++){
                letters[m][ll[n]-‘a‘]++;
            }
        }

        vector<string> t;
        for (int a=0;a<s.size()-1;a++){
            for(int b=a+1;b<s.size();b++){
                for(int c=0;c<26;){
                if (letters[a][c]==letters[b][c])
                {
                    c=c+1;
                }
                else{
                    continue;
                }
            }
            t.push_back(s[a]);
            s[a]=" ";
            t.push_back(s[b]);
        }
        return t;
    }
};

二次参考:http://blog.csdn.net/wangyuquanliuli/article/details/45792029

解决思路很简单:对每个字符串进行排序,然后用hash表记录个数就行

class Solution {
public:
    /**
     * @param strs: A list of strings
     * @return: A list of strings
     */
    vector<string> anagrams(vector<string> &strs) {//vector<string> s;   定义个一个字符串容器s
        // write your code here
        //分析:对每个字符串进行排序,然后用hash表记录个数就行

        map<string,int> m;  //定义一个关联容器(hash表),提供一对一的数据处理能力。初始值为0;
        for(auto s:strs)  //s与strs[i]属于同种类型,也就是说,都是字符串,从第一个字符串到最后一个字符串;
        {
            sort(s.begin(),s.end());  //对字符串数组中的每个字符串进行排序
            m[s]++;  //将排序后的s,他的值加1,但这个排序不影响strs本身,只作用于for里面。
        }
        vector<string> ret;  //定义一个字符串容器
        for(auto s:strs)
        {
            auto temp = s;
            sort(temp.begin(),temp.end());  //将每个字符串排序,如果排序之后,发现最后的m[temp]值大于1,则说明是乱序。
            if(m[temp]>1)
                ret.push_back(s);  //把乱序的字符串放到容器中,这样遍历每个字符串,就可以得到最终的结果。
        }
        return ret;
    }
};

1. 关于字符串容器的定义和操作:

vector<string> vec;//定义个一个字符串容器,相当于字符串数组;
string str;
str = "abc";
vec.push_back(str);//把字符串str压进容器,必须使用push_back()动态添加新元素
vec.push_back("def");//把字符串"def"压进容器
vec.push_back("123");
for(int i=0; i<vec.size(); i++)
{
cout<<vec[i]<<endl;//打印容器的内容
}
vec.pop_back();//取出容器中最后一个
for(int i=0; i<vec.size(); i++)
{
cout<<vec[i]<<endl;//打印容器的内容
}

若要一次性初始化,如下:

vec.resize(4,"abc"); //一次性有4个abc

2. 字符串相关:

【s.size()函数返回字符串s中的字符个数;s.empty()用来确认字符串s是否为空;】

【string类型拼接符"+"必须与一个string类型相邻 ,不能在两侧都是字符串常量】

注:关于hash表与HashMap原理,区别以及实现在面试中频繁出现,需要深刻理解。

3. hash表原理参考 (1). http://www.cnblogs.com/dolphin0520/archive/2012/09/28/2700000.html

(2). http://blog.chinaunix.net/uid-24951403-id-2212565.html

(3). http://kb.cnblogs.com/page/189480/

4. HashMap原理参考 (1). http://blog.csdn.net/vking_wang/article/details/14166593#t0

(2). http://my.oschina.net/boxizen/blog/177744

时间: 2024-11-06 12:35:38

Lintcode--003的相关文章

【Lintcode】003.Digit Counts

题目: Count the number of k's between 0 and n. k can be 0 - 9. Example if n = 12, k = 1 in [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12] we have FIVE 1's (1, 10, 11, 12) 题解: Solution 1 () class Solution { public: int digitCounts(int k, int n) { if (n < 0)

[lintcode the-smallest-difference]最小差(python)

题目链接:http://www.lintcode.com/zh-cn/problem/the-smallest-difference/ 给定两个整数数组(第一个是数组 A,第二个是数组 B),在数组 A 中取 A[i],数组 B 中取 B[j],A[i] 和 B[j]两者的差越小越好(|A[i] - B[j]|).返回最小差. 排好序后用两个指针分别扫描两个数组,每次更新他们的差值的绝对值.并且依据他们两个数字的大小来决定谁来移动指针. 1 class Solution: 2 # @param

lintcode.44 最小子数组

最小子数组 描述 笔记 数据 评测 给定一个整数数组,找到一个具有最小和的子数组.返回其最小和. 注意事项 子数组最少包含一个数字 您在真实的面试中是否遇到过这个题? Yes 哪家公司问你的这个题? Airbnb Amazon LinkedIn Cryptic Studios Dropbox Apple Epic Systems TinyCo Yelp Hedvig Zenefits Uber Snapchat Yahoo Microsoft Bloomberg Facebook Google

lintcode 66.67.68 二叉树遍历(前序、中序、后序)

AC代码: /** * Definition of TreeNode: * public class TreeNode { * public int val; * public TreeNode left, right; * public TreeNode(int val) { * this.val = val; * this.left = this.right = null; * } * } */ public class Solution { /** * @param root: The r

[LintCode/LeetCode]——两数和、三数和、四数和

LintCode有大部分题目来自LeetCode,但LeetCode比较卡,下面以LintCode为平台,简单介绍我AC的几个题目,并由此引出一些算法基础. 1)两数之和(two-sum) 题目编号:56,链接:http://www.lintcode.com/zh-cn/problem/two-sum/ 题目描述: 给一个整数数组,找到两个数使得他们的和等于一个给定的数 target. 你需要实现的函数twoSum需要返回这两个数的下标, 并且第一个下标小于第二个下标.注意这里下标的范围是 1

Lintcode 469. 等价二叉树

----------------------------------------------- AC代码: /** * Definition of TreeNode: * public class TreeNode { * public int val; * public TreeNode left, right; * public TreeNode(int val) { * this.val = val; * this.left = this.right = null; * } * } */

Lintcode 75.寻找峰值

--------------------------------------- 按照给定的峰值定义,峰值的左半部分一定是递增的,所以只要找到不递增的即可. AC代码: class Solution { /** * @param A: An integers array. * @return: return any of peek positions. */ public int findPeak(int[] A) { for(int i=1;i<A.length;i++){ if(A[i]>=

Lintcode 9.Fizz Buzz 问题

------------------------ AC代码: class Solution { /** * param n: As description. * return: A list of strings. */ public ArrayList<String> fizzBuzz(int n) { ArrayList<String> results = new ArrayList<String>(); for (int i = 1; i <= n; i++

Lintcode 97.二叉树的最大深度

--------------------------------- AC代码: /** * Definition of TreeNode: * public class TreeNode { * public int val; * public TreeNode left, right; * public TreeNode(int val) { * this.val = val; * this.left = this.right = null; * } * } */ public class S

[Lintcode two-sum]两数之和(python,双指针)

题目链接:http://www.lintcode.com/zh-cn/problem/two-sum/ 给一个整数数组,找到两个数使得他们的和等于一个给定的数target. 备份一份,然后排序.搞两个指针分别从左从右开始扫描,每次判断这两个数相加是不是符合题意,如果小了,那就把左边的指针向右移,同理右指针.然后在备份的数组里找到位置. 1 class Solution: 2 """ 3 @param numbers : An array of Integer 4 @param